
  # REGISTRY_URL
  # REGISTRY_USERNAME
  # REGISTRY_PASSWORD
  # REGISTRY_PROJECT
    
pack_build_and_publish:
  stage: publish
  image: docker:20.10.13
  services:
  - name: docker:20.10.13-dind
    alias: docker
  needs:
  - job: build
    artifacts: true
  cache:
    - key: pack-cli
      paths:
        - .pack-cli/
  before_script:
    - >
      if [ ! -f .pack-cli/pack ]; then
        wget https://github.com/buildpacks/pack/releases/download/$PACK_VERSION/pack-$PACK_VERSION-linux.tgz -O pack.tgz;
        tar xzf pack.tgz
        rm pack.tgz
        mkdir .pack-cli
        chmod +x pack
        mv pack .pack-cli/
      fi
  script:
    - |
      if [ -S /var/run/docker.sock ]; then
        unset DOCKER_HOST
        unset DOCKER_TLS_CERTDIR
      else
        while ! nc -z docker 2375; do   
          sleep 1  # wait for docker dind to start
        done
      fi
    - echo "$REGISTRY_PASSWORD" | docker login --username "$REGISTRY_USERNAME" --password-stdin $REGISTRY_URL
    - .pack-cli/pack build $REGISTRY_URL/$REGISTRY_PROJECT:$VERSION --builder $BUILDER --trust-builder --publish  --path $(dirname $(find $PWD -type f -iname $PROJECT.csproj))
  variables:
    PACK_VERSION: v0.24.0
    BUILDER: paketobuildpacks/builder:0.1.158-base
    DOCKER_HOST: tcp://docker:2375
    DOCKER_TLS_CERTDIR: ""